@ECHO off

SET ROOT=%CD%

SET CMDERR=0

SET LOG_ADD=Log\run.log

SET SYSFILENAME32=iqvw32.sys

SET SYSFILENAME64=iqvw64e.sys

SET SYSTEMSKU="NULL"

SET OS_VER="NULL"

REM --------------------- SET TIME FORMAT. --------------------- 

REM SET hh=%time:~0,2%
REM IF "%time:~0,1%"==" " SET hh=0%hh:~1,1%   
REM SET dt=%date:~7,2%-%date:~4,2%-%date:~10,4%_%hh%_%time:~3,2%_%time:~6,2%

REM -------------------------CHECK BIOS IS TARGET SYSTEM---------------------------
WMIC bios get smbiosbiosversion | find /i "n1h" > NUL && set SYSTEMSKU="TargetL"
WMIC bios get smbiosbiosversion | find /i "n1i" > NUL && set SYSTEMSKU="TargetN"

IF %SYSTEMSKU%=="TargetL" ( 
    GOTO FLASH
) ELSE IF %SYSTEMSKU%=="TargetN" ( 
    GOTO FLASH
) ELSE (
	SET CMDERR=255
    GOTO ERROR_UNSUP_SYSTEM
)

:FLASH

ECHO %DATE% %TIME% : ------------------- START ------------------------ >> %ROOT%\%LOG_ADD%


REM --------------------- CHECK SYSTEM OS ----------------------------

WMIC os get version | find /i "10.0" > NUL && set OS_VER="WIN10"

REM --------------------- CHECK OS ARCHITECTURE. ---------------------

REG Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OSarch=32BIT || set OSarch=64BIT

IF %OSarch%==32BIT ( 
	GOTO WINx32
) ELSE IF %OSarch%==64BIT ( 
	GOTO WINx64
) ELSE (
	SET CMDERR=255
	GOTO ERROR
)

ECHO %DATE% %TIME% : OS bit=%OSarch% >> %ROOT%\%LOG_ADD%

REM --------------------- WIN 32bit UPDATE ---------------------

:WINx32

ECHO %DATE% %TIME% : DEBUG: Win32 >> %ROOT%\%LOG_ADD%

IF %OS_VER%=="NULL" (
	ECHO %DATE% %TIME% : DEBUG: Copying Driver %SYSFILENAME32%! >> %ROOT%\%LOG_ADD%
	copy PhyID\Win32\%SYSFILENAME32% %systemroot%\system32\drivers\. /y >> %ROOT%\%LOG_ADD%
	ECHO. >> %ROOT%\%LOG_ADD%
) ELSE (
	CD PhyID\Win32
	ECHO %DATE% %TIME% : DEBUG: Installing driver %SYSFILENAME32%! >> %ROOT%\%LOG_ADD%
	ECHO. >> %ROOT%\%LOG_ADD%
	CALL install.bat /y >> %ROOT%\%LOG_ADD%
	ECHO. >> %ROOT%\%LOG_ADD%
	CD %ROOT%
)





IF EXIST %systemroot%\system32\drivers\%SYSFILENAME32% (
	ECHO %DATE% %TIME% : DEBUG: %SYSFILENAME32% copy successful! >> %ROOT%\%LOG_ADD%
) ELSE (
	ECHO %DATE% %TIME% : DEBUG: %SYSFILENAME32% copy unsuccessful! >> %ROOT%\%LOG_ADD%
	SET CMDERR=255
	GOTO ERROR
)

ECHO %DATE% %TIME% : DEBUG: Checking system LAN device type! >> %ROOT%\%LOG_ADD%

ECHO. >> %ROOT%\%LOG_ADD%

PhyID\Win32\PhyIDW32.exe >> %ROOT%\%LOG_ADD%

IF %ERRORLEVEL% EQU 7 GOTO UPDATELM32

IF %ERRORLEVEL% EQU 8 GOTO UPDATEV32


REM --------------------- NOT A SUPPORTED DEVICE ---------------------

SET CMDERR=2

GOTO ERROR_UNSUP

:UPDATELM32

ECHO %DATE% %TIME% : DEBUG: Update i219LM 32bit. >> %ROOT%\%LOG_ADD%

CD GbENVMUpdater\i219LM\Win32

Lenovo_NVM_UpdateW32.exe -silent -log update.log

SET CMDERR=%ERRORLEVEL%

ECHO %DATE% %TIME% : DEBUG: Update Return code=%CMDERR% >> %ROOT%\%LOG_ADD%

GOTO END

:UPDATEV32

ECHO %DATE% %TIME% : DEBUG: Update i219V 32bit. >> %ROOT%\%LOG_ADD%

CD GbENVMUpdater\i219V\Win32

Lenovo_NVM_UpdateW32.exe -silent -log update.log

SET CMDERR=%ERRORLEVEL%

ECHO %DATE% %TIME% : DEBUG: Update Return code=%CMDERR% >> %ROOT%\%LOG_ADD%

GOTO END

REM --------------------- WIN 64bit UPDATE ---------------------

:WINx64

ECHO %DATE% %TIME% : DEBUG: Win64 >> %ROOT%\%LOG_ADD%

IF %OS_VER%=="NULL" (
	ECHO %DATE% %TIME% : DEBUG: Copying Driver %SYSFILENAME64%! >> %ROOT%\%LOG_ADD%
	COPY PhyID\Win64e\%SYSFILENAME64% %systemroot%\system32\drivers\. /y >> %ROOT%\%LOG_ADD%
	ECHO. >> %ROOT%\%LOG_ADD%
) ELSE (
	CD PhyID\Win64e
	ECHO %DATE% %TIME% : DEBUG: Installing driver %SYSFILENAME64%! >> %ROOT%\%LOG_ADD%
	ECHO. >> %ROOT%\%LOG_ADD%
	CALL install.bat /y >> %ROOT%\%LOG_ADD%
	ECHO. >> %ROOT%\%LOG_ADD%
	CD %ROOT%
)

IF EXIST %systemroot%\system32\drivers\%SYSFILENAME64% (
	ECHO %DATE% %TIME% : DEBUG: %SYSFILENAME64% copy successful! >> %ROOT%\%LOG_ADD%
) ELSE (
	ECHO %DATE% %TIME% : DEBUG: %SYSFILENAME64% copy unsuccessful! >> %ROOT%\%LOG_ADD%
	SET CMDERR=255
	GOTO ERROR
)

ECHO %DATE% %TIME% : DEBUG: Checking system LAN device type! >> %ROOT%\%LOG_ADD%

ECHO. >> %ROOT%\%LOG_ADD%

PhyID\Win64e\PhyIDW64e.exe >> %ROOT%\%LOG_ADD%

IF %ERRORLEVEL% EQU 7 goto UPDATELM64

IF %ERRORLEVEL% EQU 8 goto UPDATEV64

REM --------------------- NOT A SUPPORTED DEVICE ---------------------

SET CMDERR=2

GOTO ERROR_UNSUP

:UPDATELM64

ECHO %DATE% %TIME% : DEBUG: Update i219LM 64bit. >> %ROOT%\%LOG_ADD%

CD GbENVMUpdater\i219LM\Win64e

Lenovo_NVM_UpdateW64e.exe -silent -log update.log

SET CMDERR=%ERRORLEVEL%

ECHO %DATE% %TIME% : DEBUG: Update Return code=%CMDERR% >> %ROOT%\%LOG_ADD%

GOTO END

:UPDATEV64

ECHO %DATE% %TIME% : DEBUG: Update i219V 64bit. >> %ROOT%\%LOG_ADD%

CD GbENVMUpdater\i219V\Win64e

Lenovo_NVM_UpdateW64e.exe -silent -log update.log

SET CMDERR=%errorlevel%

ECHO %DATE% %TIME% : DEBUG: Update Return code=%CMDERR% >> %ROOT%\%LOG_ADD%

GOTO END

:ERROR

ECHO %DATE% %TIME% : ERROR: Error occured when running script! >> %ROOT%\%LOG_ADD%

GOTO END

:ERROR_UNSUP

ECHO %DATE% %TIME% : ERROR: Error no device or device is unsupported! >> %ROOT%\%LOG_ADD%

GOTO END

:ERROR_UNSUP_SYSTEM

ECHO %DATE% %TIME% : ERROR: Error system is unsupported! >> %ROOT%\%LOG_ADD%

:END

cd %ROOT%

IF EXIST %systemroot%\system32\drivers\%SYSFILENAME32% (
	DEL /F /S /Q /A %systemroot%\system32\drivers\%SYSFILENAME32% > NUL
	IF NOT EXIST %systemroot%\system32\drivers\%SYSFILENAME32% (
		ECHO %DATE% %TIME% : DEBUG: %SYSFILENAME32% delete successful! >> %ROOT%\%LOG_ADD%
	)
)

IF EXIST %systemroot%\system32\drivers\%SYSFILENAME64% (
	DEL /F /S /Q /A %systemroot%\system32\drivers\%SYSFILENAME64% > NUL
	IF NOT EXIST %systemroot%\system32\drivers\%SYSFILENAME64% (
		ECHO %DATE% %TIME% : DEBUG: %SYSFILENAME64% delete successful! >> %ROOT%\%LOG_ADD%
	)
)

ECHO %DATE% %TIME% : DEBUG: Script Return code = %CMDERR% >> %ROOT%\%LOG_ADD%

ECHO %DATE% %TIME% : ------------------- END ------------------------ >> %ROOT%\%LOG_ADD%

IF "%~1" equ "" goto notsilent
IF "%~1" equ "-s" goto silent
IF "%~1" equ "-S" goto silent

:notsilent
IF %CMDERR% equ 0 goto ERR0
IF %CMDERR% equ 1 goto ERR1
IF %CMDERR% equ 2 goto ERR2

Echo ##################
Echo # Update error!! #
Echo ##################
goto endpause

:ERR0
Echo #####################
Echo # No update needed! #
Echo #####################
goto endpause

:ERR1
Echo #########################################################
Echo # Update successful! Restart system to complete update! #
Echo #########################################################
goto endpause

:ERR2
Echo ##############################
Echo # No matching devices found! #
Echo ##############################
goto endpause

:endpause
pause

:silent

IF %CMDERR% neq 0 exit /b %CMDERR%
